#include <stdio.h>
#include <math.h>
#define n 5000
int n1,n2;
float xx[n],yy[n],a73[n],arr,dao[n],drr[n];
char mark[n],mar[n];
int m,ou;
FILE *fp;

main(int ac,char**av)
{
  int i,j,k,ccd;
  char a[99],f1[50],n5[5];
  float x1,x2,xx1,ava,sig,r,ava4,ss[2],tt[2];
  if(ac<2){ printf("\n\t****** plot 4 gate(part) calibration  *****\n");
            printf("\n\tUsage: plot_cali a5828_0043_3.cali [%]\n");
     printf("\n\tUSE /line6/cat/../a*.cali  /line7/jiang/../a*.cali\n\n");
            exit(0); }
  strcpy(f1,av[1]);
  fp=fopen(f1,"r");if(!fp){printf("\n\t%s  file not found!\n",f1); exit(0);}
  i=j=0; xx1=0.;
l10:
  fgets(a,99,fp); if(feof(fp))goto l20;
  if(a[0]=='#')goto l10;
  sscanf(&a[52],"%f %f %f %f %f %f %d",
     &xx[i],&yy[i],&a73[i],&arr,&dao[i],&drr[i],&mark[i]);
  dao[i]=a73[i]-dao[i]; drr[i]=1./(drr[i]*drr[i]+arr*arr); 
  if(mark[i]==2)j++;
  if(xx[i]>xx1)xx1=xx[i];
  if(i++<n-1)goto l10;
l20:
  fclose(fp); m=i;
  printf("%d/%d\n",j,i);
  n1=4096; n2=4032; strcpy(n5,"Gate"); 
if(xx1>4096.){ n1=8640; n2=8200; strcpy(n5,"Part"); }
  x1=x2=0.;    xx1=0.;
  for(j=k=0;j<m;j++)if(mark[j]==2){ k++; x1+=dao[j]*drr[j]; xx1+=drr[j]; }
  ava4=ava=x1/xx1;
  for(j=0;j<m;j++)if(mark[j]==2) x2+=(dao[j]-ava)*(dao[j]-ava);
  sig=sqrt(x2/k);
  printf(" av: %6.3f %6.3f\n",ava,sig);

int i0=0,i1=1,i2=2,ic;
float z1,z2;
  if(ac>2){
    pgbegin_(&i0,"/xw",&i1,&i1,3);
    x1=610., x2=600.;   pgpap_(&x1,&x2);
    x1=z1=0.; x2=n1; z2=n2; 
    pgenv_(&x1,&x2,&z1,&z2,&i0,&i0);
    for(i=0;i<m;i++)if(mark[i] && a73[i]>15. && a73[i]<21.5){
      x1=(dao[i]-ava)*9.;
      ic=2; if(x1<0.){ x1=-x1; ic=1; }   pgsci_(&ic);
      i2=x1+0.5; i2+=21;
      if(i2<27){ z1=xx[i]; z2=yy[i]; pgpoint_(&i1,&z1,&z2,&i2); }
    } pgsci_(&i1);
    pglabel_("a73-dao-cali_mag, red circle under AV","15.~~21.5m",f1,37,10,strlen(f1));
  } else {
     pgbegin_(&i0,"/xw",&i2,&i2,3);
     x1=600., x2=600.;   pgpap_(&x1,&x2);
  }
  for(j=0;j<4;j++){
    if(j==0)ccd=1;
    if(j==1)ccd=3;
    if(j==2)ccd=2;
    if(j==3)ccd=4;
    get4cali(m,ccd,&ava,&sig,&i,&k);
    if(k==0)ava=sig=0; 
    r=pow(10,(ava-4.)*0.4);
    printf("%s %d:%4d/%d   av:%8.3f%7.3f  Weight: %7.4f\n",
              n5,ccd,k,i,ava,sig,r);
    if(ac==2){
      x1=14.; x2=23.; z1=10.; z2=19.; 
      pgsci_(&i1); pgenv_(&x1,&x2,&z1,&z2,&i1,&i1);
      x1=1.5; pgsch_(&x1);
      sprintf(a,"cali:%6.3f  rms:%6.3f    %d/%d+%d",ava,sig,k,i,ou);
      x1=14.5; z1=18.0; pgtext_(&x1,&z1,a,strlen(a));
      sprintf(a,"%s: %d",n5,ccd);
      x1=20.; z1=12.0; pgtext_(&x1,&z1,a,strlen(a));
      sprintf(a,"full_pic_AV(red): %6.3f",ava4);
      x1=17.; z1=11.0; pgtext_(&x1,&z1,a,strlen(a));
      ss[0]=14.; ss[1]=23.;
      tt[0]=14.-ava4; tt[1]=23.-ava4;
      pgsci_(&i2);
      pgline_(&i2,ss,tt);
      for(i=0;i<m;i++)if(mar[i]!=1){
        ic=mar[i]*2-1; pgsci_(&ic);
        x1=a73[i]; x2=a73[i]-dao[i];
        pgpoint_(&i1,&x1,&x2,&i1);
      }
    } x1=1.; pgsch_(&x1);
  } pgend_();
}

get4cali(m,gate,ava4,sig4,m4,k4)
int m,gate,*m4,*k4; float *ava4,*sig4;
{
  int j,k,ic,mm=0;
  float ava,sig, x1,x2,xx1;
  *k4=0;  ou=0;
  for(j=0;j<m;j++){ mar[j]=(mark[j]>0)?2:1;
    if(gate==1)if(xx[j]>n1/2 || yy[j]<n2/2)mar[j]=1;
    if(gate==2)if(xx[j]>n1/2 || yy[j]>n2/2)mar[j]=1;
    if(gate==3)if(xx[j]<n1/2 || yy[j]<n2/2)mar[j]=1;
    if(gate==4)if(xx[j]<n1/2 || yy[j]>n2/2)mar[j]=1;
    if(mar[j]==2 &&(a73[j]>21.5 || a73[j]<15.)){ mar[j]=-1; ou++; }
    if(mar[j]==2)mm++;
  } *m4=mm; if(mm<8)return;
l70:
  x1=x2=xx1=0.;
  for(j=k=0;j<m;j++)if(mar[j]==2){ k++; x1+=dao[j]*drr[j]; xx1+=drr[j]; }
  ava=x1/xx1;
  for(j=0;j<m;j++)if(mar[j]==2) x2+=(dao[j]-ava)*(dao[j]-ava);
  sig=sqrt(x2/k);
  for(j=ic=0;j<m;j++)if(mar[j]==2){
    x2=dao[j]-ava; if(x2<0.)x2=-x2;
    if(x2>3.*sig){ mar[j]=-1; ic++; }
  } if(ic)goto l70;
  *ava4=ava; *sig4=sig;
  *k4=k;
}
